import 'package:flutter/material.dart';
import 'package:firebase_phone_verify_ui/bloc/app_bloc.dart';
import 'package:intl_phone_number_input/intl_phone_number_input.dart';
import 'package:firebase_phone_verify_ui/otp_screen.dart';

import 'enum.dart';

class FirebaseLoginPage extends StatefulWidget {
  _FirebaseLoginPageState createState() => _FirebaseLoginPageState();
}

class _FirebaseLoginPageState extends State<FirebaseLoginPage> {
  String uuid;
  AppBloc bloc;
  String phoneNumber;
  String phoneIsoCode = "+855";
  PhoneNumber _phoneNum;
  bool _phoneCorrect = false;

  final _editController = TextEditingController();

  @override
  void initState() {
    super.initState();
    // bloc = BlocProvider.of<AppBloc>(context);
  }

  @override
  void setState(VoidCallback fn) {
    if (mounted) {
      super.setState(fn);
    }
  }

  _onPhoneNumberChange(PhoneNumber number) {
    _phoneNum = number;
    //print(number.phoneNumber);
  }

  _onValidPhoneNumber(bool correct) {
    setState(() {
      _phoneCorrect = correct;
    });
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        FocusScope.of(context).unfocus();
      },
      child: Scaffold(
          resizeToAvoidBottomPadding: false,
          body: Stack(
            children: <Widget>[
              Padding(
                padding: const EdgeInsets.only(top: 70),
                child: Column(
                  mainAxisSize: MainAxisSize.min,
                  children: <Widget>[
                    Text("Enter phone number", style: TextStyle(fontSize: 27)),
                    SizedBox(height: 32),
                    Padding(
                        padding: const EdgeInsets.symmetric(horizontal: 32),
                        child: Container(
                          height: 64,
                          padding: EdgeInsets.all(8),
                          // color: Colors.white,
                          alignment: Alignment.center,
                          child: InternationalPhoneNumberInput(
                            initialCountry2LetterCode: "KH",
                            onInputChanged: _onPhoneNumberChange,
                            onInputValidated: _onValidPhoneNumber,
                            textFieldController: _editController,
                            formatInput: false,
                            textStyle: TextStyle(fontSize: 22),
                            inputBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                              color: Colors.grey,
                            )),
                            inputDecoration: InputDecoration(
                                hintText: "12 345 678",
                                hintStyle:
                                    TextStyle(color: Colors.grey, fontSize: 17),
                                enabledBorder: OutlineInputBorder(
                                  borderSide: BorderSide(
                                      color: Colors.grey, width: 1.0),
                                ),
                                focusedBorder: OutlineInputBorder(
                                  borderSide: BorderSide(
                                      color: Colors.grey, width: 1.0),
                                )),
                          ),
                        )),
                    SizedBox(height: 32),
                    Padding(
                      padding: const EdgeInsets.symmetric(horizontal: 32),
                      child: Text(
                          "We will send your verify code to your phone number",
                          textAlign: TextAlign.center),
                    ),
                    SizedBox(height: 16),
                    Padding(
                      padding: const EdgeInsets.symmetric(horizontal: 32),
                      child: Container(
                          width: double.infinity,
                          height: 44,
                          child: RaisedButton(
                            child: Text("Next",
                                style: TextStyle(
                                    color: Colors.white, fontSize: 17)),
                            onPressed: _phoneCorrect ? _gotoOTPScreen : null,
                          )),
                    )
                  ],
                ),
              ),
            ],
          )),
    );
  }

  _gotoOTPScreen() async {
    FirebaseVerifyResult result =
        await Navigator.push(context, MaterialPageRoute(builder: (context) {
      return OTPScreen(_phoneNum);
    }));
    if (result != null) {
      Navigator.pop(context, result);
    }
  }
}
